#include <Wire.h>
#include <LiquidCrystal.h>


LiquidCrystal lcd(12, 11, 5, 4, 3, 2);


void i2c_write(int address, byte reg, byte data)
{
  // Send output register address
  Wire.beginTransmission(address);
  Wire.write(reg);
  // Connect to device and send byte
  Wire.write(data); // low byte
  Wire.endTransmission(true);    // stop
}

byte i2c_read(int address, byte reg)
{
  byte ret;
  // Send input register address
  Wire.beginTransmission(address);
  Wire.write(reg);
  Wire.endTransmission(false);	// restart
  Wire.requestFrom(address, 1);
  ret = Wire.read();
  Wire.endTransmission(true);  // stop
  return ret;
}

#define  DEV_ADDR  (0x20 + 0)  // NOTE: 7bit address

void setup()
{
//  lcd.begin(16, 2);
//  lcd.clear();
//  lcd.display();

  Wire.begin(); // join i2c bus (address optional for master)

  i2c_write(DEV_ADDR, 0x0A, 0xAE);  // IOCON    NOTE: address of this resister just after PON
  i2c_write(DEV_ADDR, 0x00, 0x00);  // IODIRA
  i2c_write(DEV_ADDR, 0x10, 0x00);  // IODIRB

  i2c_write(DEV_ADDR, 0x19, 0x5A);  // GPIOB
}

void loop()
{
  byte inval, outval;
  char buf[16];

  outval  = 0;

  while (1) {
//    inval = i2c_read(DEV_ADDR, 0x09);
//    lcd.setCursor(0, 0);
//    sprintf(buf, "IN: %02x", inval);
//    lcd.print(buf);

    i2c_write(DEV_ADDR, 0x19, outval);  // GPIOB
    outval  = (outval + 1) & 0xFF;
  }
}

